From 35803c63be5955888a2f70886921902b02da4638 Mon Sep 17 00:00:00 2001
From: Serghei Mihai <smihai@entrouvert.com>
Date: Wed, 28 Aug 2019 17:00:54 +0200
Subject: [PATCH] astregs: return only valid mobile number in linking means
 (#35641)

---
 passerelle/apps/astregs/models.py             | 10 +++---
 tests/data/astregs/Contact.xml                |  2 +-
 tests/data/astregs/ContactWithWrongMobile.xml |  1 +
 tests/test_astregs.py                         | 32 +++++++++++++++----
 4 files changed, 34 insertions(+), 11 deletions(-)
 create mode 100644 tests/data/astregs/ContactWithWrongMobile.xml

diff --git a/passerelle/apps/astregs/models.py b/passerelle/apps/astregs/models.py
index 7dc69281..1502e7af 100644
--- a/passerelle/apps/astregs/models.py
+++ b/passerelle/apps/astregs/models.py
@@ -399,10 +399,12 @@ class AstreGS(BaseResource):
                          'value': r.AdresseMail,
                          'type': 'email'})
         if r.TelephoneMobile:
-            data.append({'id': 'mobile',
-                         'text': 'par SMS vers %s****%s' % (r.TelephoneMobile[:2], r.TelephoneMobile[-3:]),
-                         'value': r.TelephoneMobile,
-                         'type': 'mobile'})
+            mobile = ''.join((n for n in r.TelephoneMobile if n.isdigit()))
+            if mobile and mobile[:2] in ('06', '07'):
+                data.append({'id': 'mobile',
+                             'text': 'par SMS vers %s****%s' % (mobile[:2], mobile[-3:]),
+                             'value': mobile,
+                             'type': 'mobile'})
         response['data'] = data
         return response
 
diff --git a/tests/data/astregs/Contact.xml b/tests/data/astregs/Contact.xml
index fec6cf14..18bd65b9 100644
--- a/tests/data/astregs/Contact.xml
+++ b/tests/data/astregs/Contact.xml
@@ -1 +1 @@
-<?xml version='1.0' encoding='utf-8'?><soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/"><soapenv:Body><ns1:chargementResponse xmlns:ns1="http://gfi.astre.webservices/rf/gf/contact"><ns1:response><ns1:ContactReturn><ns1:idContact>13012</ns1:idContact><ns1:CodeContact>AS173957</ns1:CodeContact><ns1:CodeTitreCivilite>035</ns1:CodeTitreCivilite><ns1:Nom>MARTIN</ns1:Nom><ns1:Prenom>Jean-Marc</ns1:Prenom><ns1:NomDeJeuneFille></ns1:NomDeJeuneFille><ns1:DateDeNaissance></ns1:DateDeNaissance><ns1:FormuleCivilite></ns1:FormuleCivilite><ns1:IntituleTitre2></ns1:IntituleTitre2><ns1:IntituleTitre3></ns1:IntituleTitre3><ns1:IntituleTitre4>Président de l&amp;#39;</ns1:IntituleTitre4><ns1:SituationDeFamille></ns1:SituationDeFamille><ns1:CodeFonction></ns1:CodeFonction><ns1:LibelleFonction></ns1:LibelleFonction><ns1:TelephoneBureau></ns1:TelephoneBureau><ns1:TelephoneMobile>0660909980</ns1:TelephoneMobile><ns1:NumeroDeFax></ns1:NumeroDeFax><ns1:AdresseMail>jeanmarcallan@neuf.fr</ns1:AdresseMail><ns1:PageWeb></ns1:PageWeb><ns1:AdresseDestinataire>Jean-Marc MARTIN</ns1:AdresseDestinataire><ns1:AdresseComplementaire></ns1:AdresseComplementaire><ns1:ComplementGeographique></ns1:ComplementGeographique><ns1:RueVoie>271 chemin de Curnier</ns1:RueVoie><ns1:ComplementVoie></ns1:ComplementVoie><ns1:CodePostal>06750</ns1:CodePostal><ns1:Ville>SERANON</ns1:Ville><ns1:CodePays>FR</ns1:CodePays><ns1:LibellePays>France</ns1:LibellePays><ns1:LibelleAdresse>SIEGE SOCIAL</ns1:LibelleAdresse><ns1:Commentaire></ns1:Commentaire></ns1:ContactReturn></ns1:response></ns1:chargementResponse></soapenv:Body></soapenv:Envelope>
+<?xml version='1.0' encoding='utf-8'?><soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/"><soapenv:Body><ns1:chargementResponse xmlns:ns1="http://gfi.astre.webservices/rf/gf/contact"><ns1:response><ns1:ContactReturn><ns1:idContact>13012</ns1:idContact><ns1:CodeContact>AS173957</ns1:CodeContact><ns1:CodeTitreCivilite>035</ns1:CodeTitreCivilite><ns1:Nom>FOO</ns1:Nom><ns1:Prenom>Foo-Marc</ns1:Prenom><ns1:NomDeJeuneFille></ns1:NomDeJeuneFille><ns1:DateDeNaissance></ns1:DateDeNaissance><ns1:FormuleCivilite></ns1:FormuleCivilite><ns1:IntituleTitre2></ns1:IntituleTitre2><ns1:IntituleTitre3></ns1:IntituleTitre3><ns1:IntituleTitre4>Président de l&amp;#39;</ns1:IntituleTitre4><ns1:SituationDeFamille></ns1:SituationDeFamille><ns1:CodeFonction></ns1:CodeFonction><ns1:LibelleFonction></ns1:LibelleFonction><ns1:TelephoneBureau></ns1:TelephoneBureau><ns1:TelephoneMobile>06 67 78 89 90</ns1:TelephoneMobile><ns1:NumeroDeFax></ns1:NumeroDeFax><ns1:AdresseMail>foo@example.com</ns1:AdresseMail><ns1:PageWeb></ns1:PageWeb><ns1:AdresseDestinataire>Foo FOO</ns1:AdresseDestinataire><ns1:AdresseComplementaire></ns1:AdresseComplementaire><ns1:ComplementGeographique></ns1:ComplementGeographique><ns1:RueVoie>271 chemin de Curnier</ns1:RueVoie><ns1:ComplementVoie></ns1:ComplementVoie><ns1:CodePostal>06750</ns1:CodePostal><ns1:Ville>SERANON</ns1:Ville><ns1:CodePays>FR</ns1:CodePays><ns1:LibellePays>France</ns1:LibellePays><ns1:LibelleAdresse>SIEGE SOCIAL</ns1:LibelleAdresse><ns1:Commentaire></ns1:Commentaire></ns1:ContactReturn></ns1:response></ns1:chargementResponse></soapenv:Body></soapenv:Envelope>
diff --git a/tests/data/astregs/ContactWithWrongMobile.xml b/tests/data/astregs/ContactWithWrongMobile.xml
new file mode 100644
index 00000000..a6e348fd
--- /dev/null
+++ b/tests/data/astregs/ContactWithWrongMobile.xml
@@ -0,0 +1 @@
+<?xml version='1.0' encoding='utf-8'?><soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/"><soapenv:Body><ns1:chargementResponse xmlns:ns1="http://gfi.astre.webservices/rf/gf/contact"><ns1:response><ns1:ContactReturn><ns1:idContact>13012</ns1:idContact><ns1:CodeContact>AS173957</ns1:CodeContact><ns1:CodeTitreCivilite>035</ns1:CodeTitreCivilite><ns1:Nom>Bar</ns1:Nom><ns1:Prenom></ns1:Prenom><ns1:NomDeJeuneFille></ns1:NomDeJeuneFille><ns1:DateDeNaissance></ns1:DateDeNaissance><ns1:FormuleCivilite></ns1:FormuleCivilite><ns1:IntituleTitre2></ns1:IntituleTitre2><ns1:IntituleTitre3></ns1:IntituleTitre3><ns1:IntituleTitre4>Président de l&amp;#39;</ns1:IntituleTitre4><ns1:SituationDeFamille></ns1:SituationDeFamille><ns1:CodeFonction></ns1:CodeFonction><ns1:LibelleFonction></ns1:LibelleFonction><ns1:TelephoneBureau></ns1:TelephoneBureau><ns1:TelephoneMobile>FE 01 02 90 AB</ns1:TelephoneMobile><ns1:NumeroDeFax></ns1:NumeroDeFax><ns1:AdresseMail>foo@example.com</ns1:AdresseMail><ns1:PageWeb></ns1:PageWeb><ns1:AdresseDestinataire>Foo-Marc</ns1:AdresseDestinataire><ns1:AdresseComplementaire></ns1:AdresseComplementaire><ns1:ComplementGeographique></ns1:ComplementGeographique><ns1:RueVoie>271 chemin de Curnier</ns1:RueVoie><ns1:ComplementVoie></ns1:ComplementVoie><ns1:CodePostal>06750</ns1:CodePostal><ns1:Ville>SERANON</ns1:Ville><ns1:CodePays>FR</ns1:CodePays><ns1:LibellePays>France</ns1:LibellePays><ns1:LibelleAdresse>SIEGE SOCIAL</ns1:LibelleAdresse><ns1:Commentaire></ns1:Commentaire></ns1:ContactReturn></ns1:response></ns1:chargementResponse></soapenv:Body></soapenv:Envelope>
diff --git a/tests/test_astregs.py b/tests/test_astregs.py
index 7571a9d0..b31b5794 100644
--- a/tests/test_astregs.py
+++ b/tests/test_astregs.py
@@ -130,18 +130,38 @@ def test_association_linking_means(mocked_post, mocked_get, client, connector, a
     resp = app.get('/astregs/test/get-association-link-means', params={'association_id': '42'})
     assert len(resp.json['data']) == 2
     assert resp.json['already_paired'] == False
-    for result in resp.json['data']:
-        assert 'id' in result
-        assert 'text' in result
-        assert 'type' in result
-        assert 'value' in result
+    assert resp.json['data'][0] == {
+        'id': 'email',
+        'text': 'par courriel vers fo***@***com',
+        'value': 'foo@example.com',
+        'type': 'email'
+    }
+    assert resp.json['data'][1] == {
+        'id': 'mobile',
+        'text': 'par SMS vers 06****990',
+        'value': '0667788990',
+        'type': 'mobile'
+    }
 
     Link.objects.create(name_id='user_name_id', association_id='42', resource=connector)
     resp = app.get('/astregs/test/get-association-link-means',
                    params={'association_id': '42', 'NameID': 'user_name_id'})
     assert resp.json['already_paired'] == True
 
-
+    mocked_post.side_effect = [
+        mock.Mock(content=get_xml_file('Tiers.xml'), status_code=200,
+                  headers={'Content-Type': 'text/xml'}),
+        mock.Mock(content=get_xml_file('ContactWithWrongMobile.xml'),
+                  status_code=200, headers={'Content-Type': 'text/xml'})
+    ]
+    resp = app.get('/astregs/test/get-association-link-means', params={'association_id': '42'})
+    assert len(resp.json['data']) == 1
+    assert resp.json['data'][0] == {
+        'id': 'email',
+        'text': 'par courriel vers fo***@***com',
+        'value': 'foo@example.com',
+        'type': 'email'
+    }
 
 @mock.patch('passerelle.utils.Request.get', side_effect=search_wsdl_side_effect)
 @mock.patch('passerelle.utils.Request.post', side_effect=contact_search_side_effect)
-- 
2.23.0