From 674e4a5be02ea6d09ccdd812cebd4492209d5e54 Mon Sep 17 00:00:00 2001
From: Serghei Mihai <smihai@entrouvert.com>
Date: Thu, 5 Sep 2019 15:16:08 +0200
Subject: [PATCH 1/2] api_entreprise: update endpoints parameters description

---
 passerelle/apps/api_entreprise/models.py | 36 ++++++++++++------------
 1 file changed, 18 insertions(+), 18 deletions(-)

diff --git a/passerelle/apps/api_entreprise/models.py b/passerelle/apps/api_entreprise/models.py
index 5f198af7..36ba6c61 100644
--- a/passerelle/apps/api_entreprise/models.py
+++ b/passerelle/apps/api_entreprise/models.py
@@ -129,15 +129,15 @@ class APIEntreprise(BaseResource):
               description=_('Get association\'s documents'),
               parameters={
                   'association_id': {
-                      'description': _('association\'s SIREN or WALDEC number'),
+                      'description': _('association SIREN or RNA/WALDEC number'),
                       'example_value': '44317013900036',
                   },
                   'object': {
-                      'Description': _('request object (form number, file identifier, ...)'),
+                      'description': _('request object: form number, file identifier...'),
                       'example_value': '42'
                   },
                   'context': {
-                      'description': _('request context (MPS, APS, ... )'),
+                      'description': _('request context: MPS, APS...'),
                       'example_value': 'APS'
                   },
                   'recipient': {
@@ -178,7 +178,7 @@ class APIEntreprise(BaseResource):
               description=_('Get association\'s document'),
               parameters={
                   'association_id': {
-                      'description': _('association\'s SIREN or WALDEC number'),
+                      'description': _('association SIREN or RNA/WALDEC number'),
                       'example_value': '44317013900036',
                   },
                   'document_id': {
@@ -186,11 +186,11 @@ class APIEntreprise(BaseResource):
                       'example_value': 'A1500660325',
                   },
                   'object': {
-                      'Description': _('request object (form number, file identifier, ...)'),
+                      'description': _('request object: form number, file identifier...'),
                       'example_value': '42'
                   },
                   'context': {
-                      'description': _('request context (MPS, APS, ... )'),
+                      'description': _('request context: MPS, APS...'),
                       'example_value': 'APS'
                   },
                   'recipient': {
@@ -214,15 +214,15 @@ class APIEntreprise(BaseResource):
               description=_('Get firm\'s data from Infogreffe'),
               parameters={
                   'siren': {
-                      'description': _('firm\'s SIREN number'),
+                      'description': _('firm SIREN number'),
                       'example_value': '44317013900036',
                   },
                   'object': {
-                      'Description': _('request object (form number, file identifier, ...)'),
+                      'description': _('request object: form number, file identifier...'),
                       'example_value': '42'
                   },
                   'context': {
-                      'description': _('request context (MPS, APS, ... )'),
+                      'description': _('request context: MPS, APS...'),
                       'example_value': 'APS'
                   },
                   'recipient': {
@@ -239,15 +239,15 @@ class APIEntreprise(BaseResource):
               description=_('Get association\'s related informations'),
               parameters={
                   'association_id': {
-                      'description': _('association\'s SIRET or WALDEC number'),
+                      'description': _('association SIRET or RNA/WALDEC number'),
                       'example_value': '44317013900036',
                   },
                   'object': {
-                      'Description': _('request object (form number, file identifier, ...)'),
+                      'description': _('request object: form number, file identifier...'),
                       'example_value': '42'
                   },
                   'context': {
-                      'description': _('request context (MPS, APS, ... )'),
+                      'description': _('request context: MPS, APS... '),
                       'example_value': 'APS'
                   },
                   'recipient': {
@@ -264,15 +264,15 @@ class APIEntreprise(BaseResource):
               description=_('Get firm\'s related informations'),
               parameters={
                   'siren': {
-                      'description': _('firm\'s SIREN number'),
+                      'description': _('firm SIREN number'),
                       'example_value': '44317013900036',
                   },
                   'object': {
-                      'description': _('request object (form number, file identifier, ...)'),
+                      'description': _('request object: form number, file identifier...'),
                       'example_value': '42'
                   },
                   'context': {
-                      'description': _('request context (MPS, APS, ... )'),
+                      'description': _('request context: MPS, APS...'),
                       'example_value': 'APS'
                   },
                   'recipient': {
@@ -290,15 +290,15 @@ class APIEntreprise(BaseResource):
               description_get=_('Get firms\'s related informations'),
               parameters={
                   'siret': {
-                      'description': _('firms\'s SIRET number'),
+                      'description': _('firms SIRET number'),
                       'example_value': '44317013900036',
                   },
                   'object': {
-                      'description': _('request object (form number, file identifier, ...)'),
+                      'description': _('request object: form number, file identifier...'),
                       'example_value': '42'
                   },
                   'context': {
-                      'description': _('request context (MPS, APS, ... )'),
+                      'description': _('request context: MPS, APS...'),
                       'example_value': 'APS'
                   },
                   'recipient': {
-- 
2.23.0